 ##############################################################################
 # File   :   faxRecover.py                                                   #
 # Descr. :   This Script rebuild damaged Fax-Objects from am single Tif-File.#
 # Author's : Andrej Maak (Andrej.Maak@t-systems.com)                         #
 #            Jan Schierig (Jan.Schierig@t-systems.com)                       #
 # Created:   Wed, 22.10.03                                                   #
 # Mod.   :   Mon, 27.10.03                                                   #
 # Lang.  :   Python (External Method for Zope)                               #
 ##############################################################################

import os
import popen2
import string
import re
import StringIO
import ZODB
import Zope
import time
import zlib

def faxRecover (self, fax):

############################# PREPARE FOR REBUILDING #########################

##### Get Folder #####

    try:
      faxFolder = fax.objectValues()
      
    except:
      return '<P ALIGN=CENTER><strong>Get Faxfolder ...  Failed !</strong></P>'

##### Delete old Files #####    

    try:
      for oldItems in faxFolder:
        oldPsgz = re.search('\.png$|\.pdf$|\.ps.gz$', oldItems.getId())
        if oldPsgz != None: 
          fax.manage_addProduct['OFSP'].manage_delObjects(oldItems.getId())
    except:	  
      return '<P ALIGN=CENTER><strong>Delete old Files ... Failed !</strong></P>'

############################ START OF REBUILDING #############################
      
    for faxItems in faxFolder:
      tiffObj = re.search('\.tif$', faxItems.getId())
      
##### Create Tempfile #####

      if tiffObj != None:
        psFile = StringIO.StringIO()
        psFile.write(str(self.genGZ(faxItems,fax)))
         


##### Create PDF-File #####
	
        try:
	  psFile.seek(0)  
	  
	  PS2PDF = 'ps2pdf13'
	  ARGS = [PS2PDF,'-sPAPERSIZE=a4','-dPDFSETTINGS=/printer','-','-']
	  outdata = self.genPDF(PS2PDF,ARGS,psFile)
          psFile.close()
	  
	  try:	
	    pdfName = string.split((faxItems.getId()),'.')[0] + '.pdf'
	    fax.manage_addProduct['OFSP'].manage_addFile(id=pdfName, file=outdata, content_type='application/pdf')		
          except:
	    return '<P ALIGN=CENTER><strong>Writing PDF-File into ZOPE-DB ... Failed !</strong></P>'	  
	  	  
        except:
	  return '<P ALIGN=CENTER><strong>Create PDF-File ... Failed !</strong></P>'
	  	

##### Create PNG's #####	

       
        self.genPNG(faxItems,fax)



