######################################################################################################
# 
# File:		rotateFax.py
# Description:	Script rotating images and pdf-files that are given to this script as Zope-Objects
# Author's:	Jan Schierig (Jan.Schierig@t-systems.com), 
#		Andrej Maak (Andrej.Maak@t-systems.com)
# Created:	Wed Aug 6 2003
# Modified:     Thu Nov 06 2003
# Language:	Python (External Method for Zope)
#
######################################################################################################

import sys
import os
import popen2
import string
import re
import StringIO
import ZODB
import Zope
import gzip
import time
import zlib
import PIL.Image

def rotateFax(self, dir, degree):


  try:
    dirEntries = dir.objectValues()
  except:
    return 'ERROR: Failure descending into Fax-Folder'
 
 # CHECK EXISTENCE OF ROTATION-PROPERTY AND SET VALUES 
  if dir.hasProperty('rotation'):
     rot = int(dir.getProperty('rotation')) + int(degree)
     if rot >= 360:
        rot = int(rot) - 360
     dir.manage_changeProperties( { 'rotation' : rot } )
  else:
     dir.manage_addProperty('rotation', degree, 'int')
     rot = degree


 # CHECK EXISTENCE OF faxXXXXX.PS.GZ AND CREATION 
  hit = 0
  for listedFile in dirEntries:
    compr = re.search('\.ps.gz$',listedFile.getId())
    if compr != None:
      hit = 1
      #test if gz-archive is valid
#      try:
#        decompTest = StringIO.StringIO()
#        decompTest.write(str(listedFile.data))
#        decompTest.seek(0)
#        decompressedTest = gzip.GzipFile(fileobj=decompTest, mode='rb')
#        decompTest.close()
#      except IOError:
#        print 'Corrupt archive'
#        hit = 0
#        dir.manage_delObjects(listedFile.getId())
#        print 'Corrupt archive deleted'
  
 

  # if faxXXXXX.PS.GZ not existing	          
  if hit != 1:
    for listedFile in dirEntries:
      uncompr = re.search('\.tif$', listedFile.getId())


      if uncompr != None:
        self.genGZ(listedFile,dir)

        #try:
          #tempName = str(time.time()) + '.tif'
          #tempPath = 'faxTemp/' + tempName
          #incomeFile = StringIO.StringIO()
          #incomeFile.write(str(listedFile.data))
          #incomeFile.seek(0)
          #generate temporary file for conversion tiff2ps
          #tempFile = open(tempPath,'w')
          #tempFile.write(incomeFile.read())
          #incomeFile.close()
          #tempFile.close()
        #except:
         # pass         


        #execution of tiff2ps without Zombie-Process
        #TIFF2PS = self.TIFF2PS_CMD + ' ' + tempPath
        #print TIFF2PS 
        #output = os.popen(TIFF2PS,'r')
        #psFile = StringIO.StringIO(output.read())
        #psFile.seek(0)
        #output.close()

        #delete temporary file
        #DEL = 'rm ' + tempPath
        #os.system(DEL)

        #compress generated ps to gzip-archive
        #gzBuf = zlib.compress(psFile.read(),9)

        #gzBuf = StringIO.StringIO()
        #gzFile = gzip.GzipFile(mode='w', fileobj = gzBuf, compresslevel = 9)
        #gzFile.write(psFile.read())
        #gzFile.close()

        #psFile.close()

        #set name for ps.gz-file
        #name = string.split((listedFile.getId()),'.')[0] + '.ps.gz'

        #write ps.gz-stream to Zope-Object.data
        #dir.manage_addProduct['OFSP'].manage_addFile(id=name, file=gzBuf, content_type='application/x-gzip')
    	#gzBuf.close()

        #dir.manage_addProduct['OFSP'].manage_addFile(id=name, file=gzFile, content_type='application/x-gzip')
    	#gzFile.close()
    
        #Reread directory entries because of new gz-file
        dirEntries = dir.objectValues()



  #find pdf-File
  for listedFile in dirEntries:
    m = re.search('\.pdf$',listedFile.getId())
    if m != None:
      pdfObject = listedFile 


  # search for ps- and png-Files and call rotate-Funktion for each found Object	 
  for listedFile in dirEntries:
    m1 = re.search('\.gz$',listedFile.getId())
    m2 = re.search('\.png$',listedFile.getId())
    if m1 != None:
      m1 = None
      rotateFile(self,listedFile,rot,'ps',pdfObject)
    elif m2 != None:
      m2 = None
      rotateFile(self,listedFile,degree,'png',pdfObject)
    else:
      pass 
 
  return 0 




def rotateFile(self,object,rotDegree,mode,pdfObject):  
  
  #prepare binary image data for writing to buffer
  indata = object.data	
  #write binary data into Buffer    
  infile = StringIO.StringIO()
  infile.write(str(indata))
  infile.seek(0)

  #Rotation-sequenz for png-Files
  if mode == 'png':

    in_pic = PIL.Image.open(infile)

    out_pic = in_pic.rotate(int(rotDegree)*(-1))

    final_pic = StringIO.StringIO()
    out_pic.save(final_pic,'png')
    final_pic.seek(0)
    
    get_transaction()

    object.ZCacheable_invalidate()
    object.update_data(final_pic.read())
    final_pic.close()

    get_transaction().commit()


    #switch width/height properties only if rotDegree == 90
    if str(rotDegree) == '90' or str(rotDegree) == '270':
      try:
        buf = object.getProperty('height')
        object.manage_changeProperties(height = object.getProperty('width'), width = buf)
      except:
        pass
    else:
      pass
    
    


  #rotation-sequenz for ps-File
  if mode == 'ps':

    #Decompress fax-XXXX.ps.gz 
    #decompressedFile = zlib.decompress(infile.read())
    decompressedFile = gzip.GzipFile(fileobj=infile, mode='rb')
 

    #prepare rotation-params and commands

    if str(rotDegree) == '0':
      PARAMS = ''
  
    elif str(rotDegree) == '90':
      PARAMS = '-g8420x5950'
      ROTATE = self.ROTATE_PS_CMD + ' "1:R(0,595)" /dev/stdin >/dev/stdout'
      
    elif str(rotDegree) == '180':
      PARAMS = '-g5950x8420'
      ROTATE = self.ROTATE_PS_CMD + ' "1:U(595,842)" /dev/stdin >/dev/stdout'

    elif str(rotDegree) == '270':
      PARAMS = '-g8420x5950'
      ROTATE = self.ROTATE_PS_CMD + ' "1:L(842,0)" /dev/stdin >/dev/stdout'

    
    #set command for calling conversion-tool
    #PS2PDF = 'ps2pdf13'
    PS2PDF = self.PS2PDF_CMD

    #start rotation-process
    if str(rotDegree) != '0':
      (output, input) = popen2.popen2(ROTATE)
      #input.write(str(decomp.read()))
      input.write(decompressedFile.read())  #
      input.close()
      infile.close()    #
      pre_outdata = StringIO.StringIO()
      pre_outdata.write(output.read()) 
      os.wait()
      output.close()
      ARGS = [PS2PDF,PARAMS,'-sPAPERSIZE=a4','-dPDFSETTINGS=/printer','-','-']
    else:
      #pre_outdata = StringIO.StringIO(decomp.read())
      pre_outdata = StringIO.StringIO()
      pre_outdata.write(decompressedFile.read())   #
      infile.close()
      ARGS = [PS2PDF,'-sPAPERSIZE=a4','-dPDFSETTINGS=/printer','-','-']

    pre_outdata.seek(0)

    #convert rotated ps-file into pdf-file
    outdata = self.genPDF(PS2PDF,ARGS,pre_outdata)

    pre_outdata.close()

    get_transaction()

    #rotated pdf is written back
    pdfObject.ZCacheable_invalidate()
    pdfObject.update_data(outdata)

    #Commiting Zope-Transaction
    get_transaction().commit()


  return 0 




   
