######################################################################################################
#
# File:		searchLDAP_sort.py
# Description:  changed Implementation of searchLDAP.py only showing memebers of ldap-group itcs
# Author:	Jan Schierig (Jan.Schierig@t-systems.com)
# Created:	Mon June 2 2003
# Modified: 
# Language:	Python (External Method for Zope)
#
######################################################################################################



import ldap
import string
import Zope


def searchLDAP(self):

  myResults = {}
  uid_list = []
  connect_state = 0
  i = 0
  j = 0

  
  #get object acl_users to use its ldap-server
  try:
    acl_users = getattr(self, 'acl_users')
  except:
    return 'ERROR: get acl_users'

  
  #get ldap-server of acl_users
  LDAP_SERVER_LIST = acl_users.getServers()
  i = len(LDAP_SERVER_LIST) 
  
  #try to connect to first responding ldap-server
  while connect_state != 1:
    if j >= i:
      return 'ERROR: LDAPConnectionError'
          
    LDAP_SERVER = LDAP_SERVER_LIST[j]['host'] + ':' + str(LDAP_SERVER_LIST[j]['port']) 

    try:
      l = ldap.open(LDAP_SERVER)
      result_id = l.search('dc=c1,dc=dsh,dc=de', ldap.SCOPE_SUBTREE , "cn=itcs", ['uniqueMember'])
      connect_state = 1
    except:
       j = j+1




  while 1:
    result_type, result_data = l.result(result_id, 0)

    if(result_data == []):
	break
    else:
      	if result_type == ldap.RES_SEARCH_ENTRY:
		res = result_data[0][1]

		for entry in res['uniqueMember']:
			e_list = string.split(entry,",")
			u_list = string.split(e_list[0],"=")
			uid_list.append(u_list[1])	

	

  for user in uid_list:

    match = 'uid=' + user

    
    try: 
      result_id = l.search(self.LDAP_SEARCH,ldap.SCOPE_SUBTREE, match, ['uid', 'sn', 'givenName'])
    except:
      err = 'LDAPSearchError'
      return err

    while 1:
      result_type, result_data = l.result(result_id, 0)

      if(result_data == []):
          break
      else:
	  if result_type == ldap.RES_SEARCH_ENTRY:
		res = result_data[0][1]

		uid = res['uid'][0]	
		name = res['sn'][0] + ', ' + res['givenName'][0] + ' (' + res['uid'][0] + ')'
		
		myResults[unicode(name,'utf-8')] = unicode(res['uid'][0], 'utf-8')


  sortResults = []
  results = []
    
  for key,value in myResults.items():
    results.append((key, value))
  
  results.sort()

  for i in range(len(results)):
    sortResults.append((results[i][1], results[i][0]))
     

  #Hinzufgen eines StaTISCHEN Dummy-Users fr Testlauf
  sortResults.append(('zopetest','Zopetest'))

  return sortResults 
